leetcode:268. Missing Number

 

思路:

1.先加进map,

2.第二遍循环缺的

class Solution {
public:
    int missingNumber(vector<int>& nums) {
     
        int len=nums.size();
        if(len==0) return 0;
        
        map<int,int> mp;
        for(auto i=0;i<nums.size();i++)
        {    
            mp.insert(pair<int,int> (nums[i],0));      
            auto it=mp.find(nums[i]);
            printf("----%d ,%d \n",(*it).first,(*it).second);
        }
        
        for(auto v : mp){  
            printf("%d ,%d \n",v.first,v.second);
        }
       
        int inorder=0;
        for(auto i=0;i<nums.size();i++){
           if( mp.count(i) == 0) return i;   
           inorder=i+1;//travel to end of nums,we need to add i+1 into nums
        }
        return inorder;//if []
    }
};

太慢了。。。

class Solution {
public:
    int missingNumber(vector<int>& nums) {
        int len=nums.size();
        
        if(len==0) return 0;//if []
        
        map<int,int> mp;
        
        for(auto i=0;i<len;i++) mp.insert(pair<int,int> (nums[i],0));

        int inorder=0;//nums inorder
        for(auto i=0;i<len;i++){
           if( mp.count(i) == 0) return i;   
           inorder=i+1;//travel to end of nums,we need to add i+1 into nums
        }
        return inorder;
    }
};

我想想看,,,

数组怎么做?

排序了再比较:

class Solution {
public:
    int missingNumber(vector<int>& nums) {
        int len=nums.size();
        
        if(len==0) return 0;//if []
        
        sort(nums.begin(),nums.end());
        
         int inorder=0;//nums inorder
         for(auto i=0;i<len;i++)
         {
             if(nums[i] != i) return i;     

              if(i==len-1) inorder=i+1;//else get the end ,nums inorder
         }
         return inorder;
    }
};

依然很慢

 

大佬的:

class Solution {
public:
    int missingNumber(vector<int>& nums) {
        int result = nums.size();
        int i=0;
        
        for(int num:nums){
            result ^= num;
            result ^= i;
            i++;
        }
        
        return result;
    }
};

解释:

To summarize terbb's comment: if i is the missing number, and ^ represents XOR, we have:

 

(0^0) ^ (1^1) ^ ... ^ (i) ^ ... ^ (N^N) = 0 ^ 0 ^... ^ i ^ ...^ 0 = i

 

 

For people who don't understand this solution: what he's doing is he's using the bitwise XOR operator to single out the missing number. How? First, we need to understand the properties of XOR: firstly, XOR'ing a number by itself results in 0. So if we have 1 ^ 1, this will equal 0. Secondly, XOR is commutative and associative - what this means is we can re-order our XOR operations in any way we want and it will result in the same value we would have if we didn't. Finally, a number XOR'd by 0 will result in the same number unchanged. So, essentially, by XOR'ing all the numbers from 0 to n, and all the numbers in the array, we will end up XOR'ing 2 of every number except for the missing one.

As we know, it doesn't matter which order we XOR these numbers in - as long as we XOR 2 of the same number, it will result in 0. So eventually we will get 0 ^ the missing number, which, due to the third property I mentioned, will simply equal the missing number. If you're not convinced as to how these properties work, I would recommend taking a quick look as to how they work.

 

 

给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值